//
//  AudioPresenter.swift
//  VKExt
//
//  Created programmist_NA on 23.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import SwiftyVK
import SwiftyJSON
import KDEAudioPlayer

class AudioPresenter: AudioPresenterProtocol {

    weak private var view: AudioViewProtocol?
    var interactor: AudioInteractorProtocol?
    private let router: AudioWireframeProtocol
    var documentsDirectoryURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!

    init(interface: AudioViewProtocol, interactor: AudioInteractorProtocol?, router: AudioWireframeProtocol) {
        self.view = interface
        self.interactor = interactor
        self.router = router
    }
    
    var audioCount: Int {
        guard let interactor = self.interactor else { return 0 }
        return interactor.audioCount
    }

    func start(token: String, secret: String, request: TestAudioItem.Model.Request.RequestType) {
        guard let interactor = self.interactor else { return }
        interactor.start(token: token, secret: secret, request: request)
    }
    
    func onLogin(login: String, password: String) {
        interactor?.auth(login: login, password: password)
    }
    
    func presentData(response: TestAudioItem.Model.Response.ResponseType) {
        switch response {
        case .presentAudio(audio: let response):
            let cells = response.items.compactMap { audio in
                audioCellViewModel(from: audio)
            }

            let audioViewModel = AudioViewModel.init(cells: cells, footerTitle: "")
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayAudio(audioViewModel: audioViewModel))
            }
        case .presentFooterLoader:
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterLoader)
            }
        case .presentFooterError(message: let message):
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterError(message: message))
            }
        }
    }
    
    private func audioCellViewModel(from audio: Item) -> AudioViewModel.Cell {

        return AudioViewModel.Cell.init(title: audio.title, subtitle: audio.subtitle ?? "", id: audio.id, date: audio.date, url: audio.url, artist: audio.artist, ownerId: audio.ownerId, duration: audio.duration, album: audio.album ?? AudioAlbum(thumb: AudioThumb(width: 0, photo300: "", photo600: "", photo270: "", photo135: "", photo34: "", height: 0, photo68: "", photo1200: ""), ownerId: 0, id: 0, title: ""), isExplicit: audio.isExplicit, isLicensed: audio.isLicensed)
    }
    
    func onError(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.2, execute: {
            self.onEvent(message: message, style)
        })
    }
    
    func onEvent(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.1, execute: {
            self.view?.showStatusError(message: message, error: nil, style, with: false)
        })
    }
    
    func onLoaded(isErrored: Bool, errorCode: Int?) {
        if isErrored {
            let errorMessage = """
            Ошибка \(errorCode!)
            """
            DispatchQueue.main.async {
                self.view?.handleLoading(from: false)
                self.view?.showError(message: errorMessage, image: UIImage(named: "music_outline_56"))
            }
        } else {
            DispatchQueue.main.async {
                self.view?.handleLoading(from: false)
                self.view?.finish()
            }
        }
    }
    
    func onSave(audio: Audio, at indexPath: IndexPath) {
        guard let interactor = self.interactor else { return }
        interactor.save(audio: audio)
        self.view?.setProgressHidden(from: false, at: indexPath)
    }
    
    func onFinishDownload(at indexPath: IndexPath) {
        self.view?.setProgressHidden(from: true, at: indexPath)
    }
    
    func onProgressChanged(value: Float, at indexPath: IndexPath?) {
        self.view?.setProgress(from: value, at: indexPath!)
    }
}
